/*
 * BombHandler.h
 *
 *  Created on: Jan 4, 2014
 *      Author: brian
 */

#ifndef BOMBHANDLER_H_
#define BOMBHANDLER_H_

#include <memory>
#include "Bomb.h"

class BombHandler
{
public:


    static BombHandler* Instance()
    {
        if(s_pInstance == 0)
        {
            s_pInstance = new BombHandler();
            return s_pInstance;
        }
        return s_pInstance;
    }

    // add a bomb to the collection
    void addBomb(Bomb *  &aBomb );


    void updateBombs();
    void drawBombs(SDL_Renderer* pRenderer);

    void clearBombs();

    const std::vector<Bomb*> getBombs() { return m_bombs; }

private:
    BombHandler();
    ~BombHandler();

    BombHandler(const BombHandler&);
    BombHandler& operator=(const BombHandler&);

    static BombHandler* s_pInstance;
    // in play bombs
    std::vector<Bomb*> m_bombs;

};

typedef BombHandler TheBombHandler;

#endif /* BOMBHANDLER_H_ */
